package dev.fitko.fitconnect.core.util;

import com.nimbusds.jose.util.Base64;
import dev.fitko.fitconnect.api.exceptions.client.FitConnectInitialisationException;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

public final class CertificateEncoder {

    public static String convertToBase64EncodedX509Certificate(final byte[] certificateData) {
        try (InputStream certificateInputStream = new ByteArrayInputStream(certificateData)) {
            final CertificateFactory certificateFactory = CertificateFactory.getInstance("X.509");
            final X509Certificate x509Certificate = (X509Certificate) certificateFactory.generateCertificate(certificateInputStream);
            return Base64.encode(x509Certificate.getEncoded()).toString();
        } catch (final CertificateException | IOException e) {
            throw new FitConnectInitialisationException("Failed to encode certificate", e);
        }
    }
}
